<?php

require_once 'PayshopClient.php';

class PayshopClientSingleton
{
    public function __construct()
    {
    }

    static $payshopClient = null;

    /**
     * Instanciete the class
     *
     * @return PayshopClient
     */
    public static function getInstance(
        string $publicKey = null,
        string $secretKey = null,
        string $accountId = null,
        string $isProduction = null
    ) {
        if (null === self::$payshopClient) {
            try {
                self::$payshopClient = new PayshopClient(
                    $publicKey,
                    $secretKey,
                    $accountId,
                    $isProduction
                );
                
            } catch (\Exception $e) {
                $message = 'API ' . $e->getMessage();
                
                //PayshopLog::generate($message, PayshopLog::LOG_SEVERITY_ERROR);
            }
        }

        return self::$payshopClient;
    }
   
}