define(
    [
        'jquery',
        'Magento_Checkout/js/view/payment/default'
    ],
    function ($, Component) {
        'use strict';
        return Component.extend({
            defaults: {
                template: 'Payshop_Core/payment/mbway',
                phone: ''
            },

            /**
             * @returns {exports.initObservable}
             */
            initObservable: function () {
                this._super()
                    .observe([
                        'phone'
                    ]);
                return this;
            },

            /**
             * @returns {String}
             */
            getCode: function () {
                return 'payshop_mbway';
            },

            /**
             * @returns {Object}
             */
            getData: function () {
                return {
                    'method': 'payshop_mbway',
                    'additional_data': {
                        'phone': this.phone()
                    }
                };
            },

            /**
             * @returns {*|jQuery|(function(): void)}
             */
            validate: function () {
                var form = $(this.getSelector('payment-form'));

                form.validation({ focusInvalid: false });
                $('form').off('invalid-form.validate');

                return form.valid();
            },

            /**
             * @param {String} field
             * @returns {String}
             */
            getSelector: function (field) {
                return '#' + this.getCode() + '_' + field;
            },
        });
    }
);
